//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FingerDlgs.h"
//#include "HelpDlgs.h"
//#include "FileMan.h"
#include "global2.h"
//---------------------------------------------------------------------------
#pragma link "FingCli"
#pragma resource "*.dfm"
#define MaxFingerCount 16
#define BUFSIZE 16384
TFingerDlg *FingerDlg;
//---------------------------------------------------------------------------
void __fastcall RunFingerTool(TForm *Owner)
{
   if (SecureModeMsg(Owner))
      return;

   FingerDlg = new TFingerDlg(Owner);
   CenterDialog(FingerDlg,Owner);
   FingerDlg->ShowModal();
   delete FingerDlg;
}
//---------------------------------------------------------------------------
bool __fastcall GetFingerHistory(TStrings *tostrings)
{
   Global->DB->GetText(FingerHistoryKey, tostrings);
   if (!tostrings->Count) tostrings->CommaText = FingerHistory;
   return tostrings->Count>0;
}
//---------------------------------------------------------------------------
__fastcall TFingerDlg::TFingerDlg(TComponent* Owner)
	: TForm(Owner)
{
   GetFingerHistory(Query->Items);
   if (Query->Items->Count)
   {
      FingerBtn->Enabled = true;
      Query->ItemIndex = 0;
   }

   RichEdit1->Clear();
   editing = false;
   cap = Caption;

   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, Query->Font, NULL);
   RichEdit1->Font->Assign(Query->Font);
   RichEdit1->Color = color;
   Query->Color = color;

   //FingerBtn->Font->Assign(Font);
   //CancelBtn->Font->Assign(Font);
}
//---------------------------------------------------------------------------
__fastcall TFingerDlg::~TFingerDlg()
{
   //delete results;
   //delete lines;
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::CancelBtnClick(TObject *Sender)
{
   Timer1->Enabled = false;
   if (CancelBtn->Caption=="Cancel")
   {
      if (editing)
      {
         Query->Text = server;
         Query->Enabled = true;
         //Query->Items->Text = RichEdit1->Lines->Text;
         ActiveControl = Query;
         FingerBtn->Caption = "Finger";
         RichEdit1->ReadOnly = true;
         RichEdit1->Clear();
         Label1->Caption = "";
         editing = false;
         return;
      }
      FINGER->Abort();
      //results->SetSize(0);
      RichEdit1->Clear();
      RichEdit1->Lines->Add("Query cancelled!");
      CancelBtn->Caption = "Close";
      Label1->Caption = "";
   }
   else ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::QueryChange(TObject *Sender)
{
   FingerBtn->Enabled = !Query->Text.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::FingerBtnClick(TObject *Sender)
{
   if (SecureModeMsg(this))
      return;

   if (FingerBtn->Caption.Pos("Save")==1)
   {
      Global->DB->PutText(FingerHistoryKey, RichEdit1->Lines);
      //Query->Items->Text = lines->Text;
      FingerBtn->Caption = "Finger";
      CancelBtn->Caption = "Close";
      Query->Items->Text = RichEdit1->Lines->Text;
      Query->Enabled = true;
      //Query->Text = server;
      if (Query->Items->Count) Query->ItemIndex = 0;
      ActiveControl = Query;
      Label1->Caption = "";
      RichEdit1->Clear();
      editing = false;
      return;
   }

   RichEdit1->Clear();
   AnsiString query = Query->Text;
   if (query.IsEmpty())
   {
      ShowMessage("No query string specified!");
      return;
   }

   TStrings *items = Query->Items;
   int idx = items->IndexOf(query);
   if (idx >= 0)
      items->Delete(idx);
   if (items->Count > 0)
      items->Insert(0,query);
   else
      items->Add(query);
   Query->ItemIndex = 0;

   if (query.Pos("@") == 0) query = "@"+query;
   FINGER->Query = query;
   ActiveControl = Panel1;
   //results->SetSize(0);
   CancelBtn->Caption = "Cancel";
   timeout = 0; RichEdit1->Lines->Add("Connecting"); Timer1->Enabled = true;
   FingerBtn->Enabled = false;
   HelpBtn->Enabled = false;
   Query->Enabled = false;
   Label1->Caption = "";//Caption = cap;
   //lines->Clear();
   FINGER->StartQuery();
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::FINGERSessionConnected(TObject *Sender, WORD Error)
{
   if (Error==0)
   {
      RichEdit1->Lines->Text = "Connected";
      timeout = 0;
   }
   else
   {
      Timer1->Enabled = false;
      FingerBtn->Enabled = true;
      HelpBtn->Enabled = true;
      Query->Enabled = true;
      CancelBtn->Caption = "Close";
   }
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::AddLines(AnsiString &msg)
{
   AnsiString s;
   int start=1,stop=msg.Pos("\r");
   if (!stop) stop = msg.Length()+1;
   ActiveControl = RichEdit1;
   while (start <= msg.Length())
   {
      //lines->Add(msg.SubString(start,stop-start));
      RichEdit1->Lines->Add(msg.SubString(start,stop-start));

      start = stop+1;
      if (start > msg.Length())
         break;

      while (msg[start] == '\n' || msg[start] == '\r')
         start++;

      stop = start;
      while (msg[stop] != '\r' && stop <= msg.Length())
         stop++;
   }
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::FINGERDataAvailable(TObject *Sender, WORD Error)
{
   int i,len;
   char d[2048];
   //sm(Error);
   if (Error)
   {
      switch (Error)
      {
         case WSAECONNREFUSED: RichEdit1->Lines->Add("No finger service available."); break;
         case WSAETIMEDOUT: RichEdit1->Lines->Add("Host unreachable."); break;
         case 11002: RichEdit1->Lines->Add("Host not found!"); break;
         default:
            RichEdit1->Lines->Add("Error ="+String(Error));
      }
      FingerBtn->Enabled = true;
      HelpBtn->Enabled = true;
      Query->Enabled = true;
      CancelBtn->Caption = "Close";
      Label1->Caption = "";
      MessageBeep(MB_OK);
      Abort();
      return;
   }
   len = FINGER->Receive(d,sizeof(d)-1);
   if (len > 1)
   {
      for (i = 0; i < len; i++)
      {
         if (String("\r\n\0").Pos(String(d[i])) < 1)
            incomingdata = incomingdata + d[i];
         if (d[i] == '\n')
         {
            incomingdata += "\r";
            AddLines(incomingdata);
            incomingdata = "";
         }
      }
   }
}
//---------------------------------------------------------------------------
/*void __fastcall TFingerDlg::FINGERDataAvailable(TObject *Sender, WORD Error)
{
   char *buf = new char[BUFSIZE];
   int len = FINGER->Receive(buf,BUFSIZE-1); buf[len] = '\0';
   results->Write(buf,len);
   delete buf;
}*/
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::FINGERQueryDone(TObject *Sender, WORD Error)
{
   if (SecureModeMsg(this))
      return;

   SetRedraw(this,0);
   Timer1->Enabled = false;

   if (Error)
   {
      switch (Error)
      {
         case WSAECONNREFUSED: RichEdit1->Lines->Add("No finger service available."); break;
         case WSAETIMEDOUT: RichEdit1->Lines->Add("Host unreachable."); break;
         case 11002: RichEdit1->Lines->Add("Host not found!"); break;
         default:
            RichEdit1->Lines->Add("Error ="+String(Error));
      }
      FingerBtn->Enabled = true;
      HelpBtn->Enabled = true;
      Query->Enabled = true;
      CancelBtn->Caption = "Close";
      Label1->Caption = "";
      MessageBeep(MB_OK);
   }
   else
   {
      Sleep(100);
      ActiveControl = RichEdit1;
      //results->Seek(0,soFromBeginning);
      //lines->LoadFromStream(results);
      SetRedraw(this,0);
      //RichEdit1->Lines->Text = lines->Text;
      RichEdit1->Lines->Delete(0);
      //AppProcessMessages(); Sleep(100);
      //TStringList *tmp = new TStringList();
      //tmp->Text = RichEdit1->Lines->Text; RichEdit1->Lines->Clear();
      //AppProcessMessages(); Sleep(100);
      //RichEdit1->Lines->Text = tmp->Text;
      //delete tmp;
      RichEdit1->SelStart = 0;
      //lines->Clear();
      for (int i=0; i<3; i++) Application->ProcessMessages();
      SetRedraw(this,1);
      CancelBtn->Caption = "Close";
      FingerBtn->Enabled = true;
      HelpBtn->Enabled = true;
      Query->Enabled = true;
      Application->ProcessMessages();
      MessageBeep(MB_OK);

      AnsiString text = Query->Text;
      if (Query->ItemIndex>=0) Query->Items->Delete(Query->ItemIndex);
      Query->Items->Insert(0,text); Query->ItemIndex = 0;
      while (Query->Items->Count>MaxFingerCount)
         Query->Items->Delete(Query->Items->Count-1);
      if (FileExists(AppDat()))
         Global->DB->PutText(FingerHistoryKey, Query->Items);
      Label1->Caption = s(RichEdit1->Lines->Count)+" items";
   }

   SetRedraw(this,1);
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::SaveBtnClick(TObject *Sender)
{
   TSaveDialog *sd = SaveDialog1;
   if (sd->InitialDir.IsEmpty())
       sd->InitialDir = ExtractFilePath(Application->ExeName);
   sd->FileName = "*.txt";
   sd->Filter = "Text files (*.txt)|*.TXT";
   sd->Options << ofHideReadOnly;
   if (sd->Execute())
      RichEdit1->Lines->SaveToFile(SaveDialog1->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::Print1Click(TObject *Sender)
{
   RichEdit1->Print("Finger for "+Query->Text);
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::Timer1Timer(TObject *Sender)
{
   if (RichEdit1->Lines->Count==1)
      RichEdit1->Lines->Strings[0] = RichEdit1->Lines->Strings[0] + ".";
   if (timeout>=timeoutval*2)
   {
      Timer1->Enabled = false;
      FingerBtn->Enabled = false;
      HelpBtn->Enabled = false;
      Query->Enabled = false;
      FINGER->Abort();
      //results->SetSize(0);
      RichEdit1->Clear();
      RichEdit1->Lines->Add("Query timed out!");
      CancelBtn->Caption = "Close";
      Label1->Caption = "";
      //Caption = cap;
      MessageBeep(MB_OK);
   }
   timeout++;
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::EditBtnClick(TObject *Sender)
{
   server = Query->Text;
   Query->Text = "Editing finger query list";
   CancelBtn->Caption = "Cancel";
   FingerBtn->Caption = "Save";
   RichEdit1->Lines->Text = Query->Items->Text;
   RichEdit1->ReadOnly = false;
   ActiveControl = RichEdit1;
   Query->Enabled = false;
   RichEdit1->SelStart = 0;
   editing = true;
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::PopEditQueryListItemClick(TObject *Sender)
{
   EditBtnClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::PopupMenu1Popup(TObject *Sender)
{
   PopEditQueryListItem->Enabled = !editing;
   PopCopyItem->Enabled = RichEdit1->SelLength>0;
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::PopCopyItemClick(TObject *Sender)
{
   RichEdit1->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::PopSelectAllItemClick(TObject *Sender)
{
   RichEdit1->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::HelpBtnClick(TObject *Sender)
{
   //OpenHelp("Finger","Finger Client","",NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFingerDlg::SaveToFile1Click(TObject *Sender)
{
   if (SaveDialog1->Execute())
   {
      AnsiString cap = Caption; Caption = "";
      Application->ProcessMessages();
      Snooze(100);
      Caption = "Saving...";
      Application->ProcessMessages();
      Sleep(300);
      Caption = cap;
      RichEdit1->Lines->SaveToFile(SaveDialog1->FileName);
   }
}
//---------------------------------------------------------------------------
