//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "NymEncFrames.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TEncFrame *EncFrame;
//---------------------------------------------------------------------------

__fastcall TEncFrame::TEncFrame(TComponent* Owner)
        : TFrame(Owner)
{
}
//---------------------------------------------------------------------------

bool __fastcall TEncFrame::HasCap(const AnsiString &Cap)
{
   return Caps.Pos(" " + Cap + " ") > 0;
}
//---------------------------------------------------------------------------

void __fastcall TEncFrame::SetToggles()
{
   if (!HasCap("ek"))
   {
      KEY->Checked = false;
      KEY->Enabled = false;
      KEYPassword->Color = clBtnFace;
      KEYPassword->Enabled = false;
      KEYPassword->Text = "";
   }

   if (!HasCap("ekx"))
   {
      DES->Checked = false;
      DES->Enabled = false;
      DESPassword->Color = clBtnFace;
      DESPassword->Enabled = false;
      DESPassword->Text = "";

      CAS->Checked = false;
      CAS->Enabled = false;
      CASPassword->Color = clBtnFace;
      CASPassword->Enabled = false;
      CASPassword->Text = "";
   }

   if (!KEYPasswd.IsEmpty())
   {
      KEYPassword->Text = KEYPasswd;
      KEYPassword->Color = clWindow;
      KEYPassword->Enabled = true;
      KEY->Checked = true;
   }
   if (!DESPasswd.IsEmpty())
   {
      DESPassword->Text = DESPasswd;
      DESPassword->Color = clWindow;
      DESPassword->Enabled = true;
      DES->Checked = true;
   }
   if (!CASPasswd.IsEmpty())
   {
      CASPassword->Text = CASPasswd;
      CASPassword->Color = clWindow;
      CASPassword->Enabled = true;
      CAS->Checked = true;
   }

   /*if (!KEYPassword->Text.IsEmpty())
      ActiveControl = KEYPassword;
   else
   if (!DESPassword->Text.IsEmpty())
      ActiveControl = DESPassword;*/
}
//---------------------------------------------------------------------------

/*void __fastcall TNymEncFrame::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      if (KEY->Checked && KEYPassword->Text.IsEmpty())
      {
         MsgDlg(this, "Encrypt-Key is checked. You must enter a password.",
            "Error", MB_OK);
         CanClose = false;
         return;
      }
      if (DES->Checked && DESPassword->Text.IsEmpty())
      {
         MsgDlg(this, "Encrypt-3DES is checked. You must enter a password.",
            "Error", MB_OK);
         CanClose = false;
         return;
      }
      if (CAS->Checked && CASPassword->Text.IsEmpty())
      {
         MsgDlg(this, "Encrypt-CAST is checked. You must enter a password.",
            "Error", MB_OK);
         CanClose = false;
         return;
      }
   }
}*/
//---------------------------------------------------------------------------

void __fastcall TEncFrame::KEYClick(TObject *)
{
   if (KEY->Checked)
   {
      KEYPassword->Text = KEYPasswd;
      if (KEYPassword->Text.IsEmpty())
         KEYPassword->Text = GetEncryptKey();
      KEYPassword->Enabled = true;
   }
   else
   {
      KEYPasswd = KEYPassword->Text;
      KEYPassword->Clear();
      KEYPassword->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TEncFrame::DESClick(TObject *)
{
   if (DES->Checked)
   {
      DESPassword->Text = DESPasswd;
      if (DESPassword->Text.IsEmpty())
         DESPassword->Text = GetEncryptKey();
      DESPassword->Enabled = true;
   }
   else
   {
      DESPasswd = DESPassword->Text;
      DESPassword->Clear();
      DESPassword->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TEncFrame::CASClick(TObject *)
{
   if (CAS->Checked)
   {
      CASPassword->Text = CASPasswd;
      if (CASPassword->Text.IsEmpty())
         CASPassword->Text = GetEncryptKey();
      CASPassword->Enabled = true;
   }
   else
   {
      CASPasswd = CASPassword->Text;
      CASPassword->Clear();
      CASPassword->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TEncFrame::KEYPasswordEnter(TObject *)
{
   if (KEYPassword->Text.IsEmpty())
   {
      KEYPassword->Text = GetEncryptKey();
      KEYPassword->SelectAll();
   }
}
//---------------------------------------------------------------------------

void __fastcall TEncFrame::DESPasswordEnter(TObject *)
{
   if (DESPassword->Text.IsEmpty())
   {
      DESPassword->Text = GetEncryptKey();
      DESPassword->SelectAll();
   }
}
//---------------------------------------------------------------------------

void __fastcall TEncFrame::CASPasswordEnter(TObject *)
{
   if (CASPassword->Text.IsEmpty())
   {
      CASPassword->Text = GetEncryptKey();
      CASPassword->SelectAll();
   }
}
//---------------------------------------------------------------------------
