//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "NymFrames2.h"
#include "NymDlgs.h"
#include "Images256s.h"
#include "NymPrintDlgs.h"
#include "NymGenCfgNowDlgs.h"
#include "NymGenModNowDlgs.h"
#include "NymConfigs.h"
#include "ValidNymKeys.h"
#include "nymserverdlgs.h"
#include "mail2newsdlgs.h"
#include "updatestatsdlgs.h"
#include "nymrptsdlgs.h"
#include "fingerdlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "QSFrames"
#pragma resource "*.dfm"
TNymsFrame2 *NymsFrame2;
//---------------------------------------------------------------------------

TQSFrame* __fastcall OpenNymsFrame2(TForm *Owner, TPanel *Parent, const AnsiString &Path,
   TGlobal *global)
{
   assert(Owner != NULL && Parent != NULL && Path != "" && global != NULL);
   Global = global;

   NymsFrame2 = new TNymsFrame2(Owner, Parent, Path);
   return NymsFrame2;
}

//---------------------------------------------------------------------------

void __fastcall DeleteNymsFrame2(TQSFrame *Frame)
{
   delete Frame;
}

//---------------------------------------------------------------------------
// NymsFrame2
//---------------------------------------------------------------------------

__fastcall TNymsFrame2::TNymsFrame2(TComponent* Owner)
        : TQSFrame(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TNymsFrame2::TNymsFrame2(TComponent *Owner, TPanel *Parent, const AnsiString &Path)
        : TQSFrame(Owner, Parent, Path)
{
   ToolBar->DisabledImages = Images256->NymDisabled;
   ToolBar->HotImages = Images256->NymHot;
   ToolBar->Images = Images256->Nym;

   ListView->SmallImages = Images256->NymListTiny;
   ListView->LargeImages = Images256->NymList;

   LoadIndex(Path);

// we loaded listview->Font and color in QSnymwins while ini is open

   Timer2->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;

   PGP = PGPInit((TForm*)Owner);
   if (PGP == NULL || !PGP->InitSuccess)
   {
      delete PGP;
      MsgBox(Application->MainForm,
         "I'm sorry. I couldn't get PGP started. You'll need to get either PGP 6.x    \n"
         "or PGP 8.x+ for the Nym Manager. The good news is that the freeware    \n"
         "versions available from http://www.pgp.com work just fine!",
         "Bad news...",
          MB_OK);
      PostMessage(Application->MainForm->Handle, WM_QUIT, 0, 0);
      return;
   }
}
//---------------------------------------------------------------------------

__fastcall TNymsFrame2::~TNymsFrame2()
{
   delete PGP;
}
//---------------------------------------------------------------------------

/*bool __fastcall TNymsFrame2::SecureMode()
{
   if (!FileExists(AppDB()) && FileExists(AppPGP()))
   {
      MsgBox(Application->MainForm,
        "I find your QS datafile (QS.dbc) is encrypted. You will need to    \n"
        "start QS and decrypt the database before I can continue.",
         MT_INFO, MB_OK);

      return true;
   }

   return false;
}*/
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::SetNymButtons()
{
   NewBtn->Enabled = true;
   DeleteBtn->Enabled = ListView->SelCount > 0;
   OpenBtn->Enabled = ListView->SelCount == 1;
   PrintBtn->Enabled = ListView->Items->Count > 0;
}
//---------------------------------------------------------------------------

/*int __fastcall TNymsFrame2::DataTypeImageIndex(TDataType Type)
{
   if (Type.IsIndex()) return Type.IsLink() ? ImgLgFolderLink : ImgLgFolder;

   switch (Type.DataType)
   {
      case QSDB_CONTACT:   return ImgLgGeneric;
      case QSDB_ACCOUNT:   return ImgLgGeneric;
      case QSDB_MESSAGE:   return Type.IsLink() ? ImgLgMsgLink : ImgLgMsg;
      case QSDB_MAIL:      return ImgLgMsg;
      case QSDB_NEWSGROUP: return ImgLgGeneric;
      case QSDB_NOTE:      return ImgLgNote;
      case QSDB_NYM:       return ImgLgNym;
      case QSDB_PGPKEY:    return ImgLgGeneric;
      case QSDB_PROXY:     return ImgLgGeneric;
      case QSDB_REMAILER:  return ImgLgGeneric;
      case QSDB_DEFAULT:   return ImgLgGeneric;
      case QSDB_LIST:      return ImgLgGeneric;
      case QSDB_NYMSERVER: return ImgLgGeneric;
      case QSDB_INI:       return ImgLgGeneric;
   }
   return ImgLgGeneric; // QSDB_UNDEFINED
}*/
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::LoadIndex(AnsiString path)
{
   if (SecureModeMsg(Application->MainForm))
      return;
      
   if (path.Pos(QSHome) == 1)
      path = path.SubString(QSHome.Length()+2, 256);

   ListView->Items->BeginUpdate();
   ListView->Items->Clear();

   TStringList *nyms = new TStringList();
   Global->DB->GetNyms(nyms);
   GotRetired = false;

   for (int i = 0; i < nyms->Count; i++)
   {
      AnsiString nym = nyms->Strings[i];
      bool retired = IsRetired(nym);
      if (!GotRetired && retired)
         GotRetired = true;

      if (!retired || ViewRetiredItem->Checked)
      {
         TListItem *item = ListView->Items->Add();

         item->Caption = GetTok(0, nym, '\255');
         for (int i = 1; i < 11; i++)
            item->SubItems->Add(GetTok(i, nym, '\255'));

         item->SubItems->Add(nym);
      }
   }

   delete nyms;
   ListView->Items->EndUpdate();

   SetNymButtons();
}
//---------------------------------------------------------------------------

bool __fastcall TNymsFrame2::IsRetired(const AnsiString &Nym)
{
   return GetTok(10, Nym, '\255') == QSNYMRETIREDCHAR;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::ViewRetiredItemClick(TObject *)
{
   LoadIndex(Path);
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::ListViewChange(TObject *, TListItem *, TItemChange)
{
   SetNymButtons();
}
//---------------------------------------------------------------------------

AnsiString __fastcall TNymsFrame2::GetNymIndexStr(TListItem *item)
{
   assert(item->SubItems->Count == 11);

   return item->SubItems->Strings[10];
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NewNym()
{
   OpenNym("<new nym>");
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::OpenSelectedNym()
{
   assert(ListView->Selected != NULL);

   OpenNym(GetNymIndexStr(ListView->Selected));
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::SelectNymByName(const AnsiString &Name)
{
   for (int i = 0; i < ListView->Items->Count; i++)
   {
      TListItem *item = ListView->Items->Item[i];
      if (item->Caption == Name)
      {
         item->Selected = true;
         item->MakeVisible(false);
         break;
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::OpenNym(AnsiString Nym)
{
   assert(Nym == "<new nym>" || ListView->Selected != NULL);

   if (SecureModeMsg(Application->MainForm))
      return;

   if (OpenNymDialog(Application->MainForm, Nym, PGP))
   {
      ListView->Items->BeginUpdate();

      if (GetTok(10, Nym, '\255') == "x" && !ViewRetiredItem->Checked)
         ViewRetiredItem->Checked = true;
      LoadIndex(Path);

      SelectNymByName(GetTok(0, Nym, '\255'));
      ListView->Items->EndUpdate();
   }
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::DeleteSelectedNyms()
{
   AnsiString delmsg, xtra = ListView->SelCount == 1 ? "?" : "s?";
   delmsg = "Delete selected nym" + xtra;

   TForm *main = Application->MainForm;

   if (MsgBox(main, delmsg, MT_CONFIRM, MB_OKCANCEL) == IDOK)
   {
      Snooze(300);
      if( MsgBox(main, "All will be lost! Are you sure?", MT_CONFIRM, MB_YESNO) == IDYES)
      {
         Wait = true;
         int i = 0; while (i < ListView->Items->Count)
         {
            TListItem *item = ListView->Items->Item[i];

            if (item->Selected)
            {
               DeleteNym(GetNymIndexStr(item));
               item->Delete();
               continue;
            }

            i++;
         }

         Wait = false;
         SetNymButtons();
      }
   }
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TNymsFrame2::DeleteNym(const AnsiString &Nym)
{
   assert(Nym != "");

   if (SecureModeMsg(Application->MainForm))
      return;

   Global->DB->DelNym(Nym);

   if (!Wait)
      SetNymButtons();
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::RetireSelectedNyms()
{
   AnsiString retmsg, xtra = ListView->SelCount == 1 ? "?" : "s?";
   retmsg = "Retire selected nym" + xtra;

   if (MsgBox(Application->MainForm, retmsg, MT_CONFIRM, MB_OKCANCEL) == IDOK)
   {
      Wait = true;
      int i = 0; while (i < ListView->Items->Count)
      {
         TListItem *item = ListView->Items->Item[i];

         if (item->Selected)
            RetireNym(GetNymIndexStr(item));

         i++;
      }

      Wait = false;
      ViewRetiredItem->Checked = true;

      ListView->Items->BeginUpdate();
      LoadIndex(Path);
      ListView->Items->EndUpdate();

      SetNymButtons();
   }
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::RetireNym(const AnsiString &Nym)
{
   assert(Nym != "");

   if (SecureModeMsg(Application->MainForm))
      return;
      
   TNymProfile *profile = new TNymProfile();

   Global->DB->GetNym(Nym, profile);
   if (!profile->Retired)
   {
      Global->DB->DelNym(Nym);
      profile->Retire();
      Global->DB->PutNym(profile->NymIndexStr, profile);
   }

   delete profile;

   if (!Wait)
   {
      ViewRetiredItem->Checked = true;

      ListView->Items->BeginUpdate();
      LoadIndex(Path);
      ListView->Items->EndUpdate();

      SetNymButtons();
   }
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::SelectAll()
{
   ListView->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::Print()
{
   PrintNyms((TForm*)Owner, this);
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NymsNewItemClick(TObject*)
{
   NewNym();
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NymsSelectAllItemClick(TObject*)
{
   SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NymsPrintItemClick(TObject*)
{
   Print();
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NymsDeleteItemClick(TObject*)
{
   DeleteSelectedNyms();
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NymsRetireItemClick(TObject*)
{
   RetireSelectedNyms();
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NymsOpenItemClick(TObject*)
{
   OpenSelectedNym();
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::ViewMenuClick(TObject *)
{
   ViewRetiredItem->Enabled = GotRetired;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NymsMenuClick(TObject *)
{
   int count = ListView->Items->Count;
   bool hassel = ListView->Selected != NULL;

   NymsOpenItem->Enabled = hassel;
   NymsSelectAllItem->Enabled = count > 0;
   NymsPrintItem->Enabled = count > 0;
   NymsDeleteItem->Enabled = hassel;
   NymsRetireItem->Enabled = CanRetire();
}
//---------------------------------------------------------------------------

bool __fastcall TNymsFrame2::CanRetire()
{
   bool ok = false;
   for (int i = 0; i < ListView->Items->Count; i++)
   {
      TListItem *item = ListView->Items->Item[i];
      if (item->Selected && item->SubItems->Strings[9] != "x")
      {
         ok = true;
         break;
      }
   }

   return ok;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::MessageMenuClick(TObject *Sender)
{
   bool hassel = ListView->Selected;
   MessageCreateItem->Enabled = hassel;
   MessageModifyItem->Enabled = hassel;
   MessageDeleteItem->Enabled = hassel;
   MessageFrmNymItem->Enabled = hassel;
   MessageReplayItem->Enabled = hassel;

   if (hassel)
   {
      if (SecureModeMsg(Application->MainForm))
         return;
         
      TNymProfile *profile = new TNymProfile();
      int gotrb, gotrp = false;

      int count = ListView->Selected->SubItems->Count;
      AnsiString nym = ListView->Selected->SubItems->Strings[count - 1];

      Global->DB->GetNym(nym, profile);
      TStringList *rblocks = new TStringList();
      profile->GetReplyBlocks(rblocks);
      gotrb = rblocks->Count > 1;
      delete rblocks;

      for (int i = 0; i < profile->Count; i++)
      {
         AnsiString line = profile->Strings[i];

         if (line.Pos("Log:") == 1)
            break;

         if (line.Pos("Sent:") == 1 && !profile->Strings[i + 1].IsEmpty())
         {
            gotrp = true;
            break;
         }
      }

      MessageReplayItem->Enabled = gotrb && gotrp;
      delete profile;
   }
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::MessageCreateItemClick(TObject *Sender)
{
   assert(ListView->Selected != NULL);

   if (SecureModeMsg(Application->MainForm))
      return;

   if (CheckNeedsRListUpdate())
      return;

   bool preview;
   TNymProfile *profile = new TNymProfile();
   TStringList *Template = new TStringList();

   for (int i = 0; i < ListView->Items->Count; i++)
   {
      TListItem *item = ListView->Items->Item[i];
      if (!item->Selected)
         continue;

      assert(item->SubItems->Count > 0);
      AnsiString key = item->SubItems->Strings[item->SubItems->Count - 1];
      Global->DB->GetNym(key, profile);

      if (!CheckValidKeyForProfile((TForm*)Owner, PGP, profile))
      {
         delete Template;
         delete profile;
         return;
      }

      if (GenNymCreateMessage((TForm*)Owner, preview, Template))
      {
         TNymConfig *nymconfig = new TNymConfig((TForm*)Owner, PGP, profile);
         nymconfig->CreateNymCreateMessage(Template, preview);
         delete nymconfig;
      }
   }

   delete Template;
   delete profile;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::MessageModifyItemClick(TObject *Sender)
{
   assert(ListView->Selected != NULL);

   if (SecureModeMsg(Application->MainForm))
      return;
      
   if (CheckNeedsRListUpdate())
      return;

   TNymProfile *profile = new TNymProfile();
   TStringList *Template = new TStringList();
   bool preview = false, cmds = false, rblk = false, key = false;

   for (int i = 0; i < ListView->Items->Count; i++)
   {
      TListItem *item = ListView->Items->Item[i];
      if (!item->Selected)
         continue;

      assert(item->SubItems->Count > 0);
      AnsiString nymkey = item->SubItems->Strings[item->SubItems->Count - 1];
      Global->DB->GetNym(nymkey, profile);

      if (!CheckValidKeyForProfile((TForm*)Owner, PGP, profile))
      {
         delete Template;
         delete profile;
         return;
      }

      if (GenNymModifyMessage((TForm*)Owner, preview, Template, cmds, key, rblk, profile))
      {
         TNymConfig *nymconfig = new TNymConfig((TForm*)Owner, PGP, profile);
         nymconfig->CreateModifyMessage(Template, preview, cmds, key, rblk, "");
         delete nymconfig;
      }
   }

   delete Template;
   delete profile;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::MessageDeleteItemClick(TObject *Sender)
{
   assert(ListView->Selected != NULL);

   if (SecureModeMsg(Application->MainForm))
      return;
      
   TNymProfile *profile = new TNymProfile();
   TStringList *Template = new TStringList();

   for (int i = 0; i < ListView->Items->Count; i++)
   {
      TListItem *item = ListView->Items->Item[i];
      if (!item->Selected)
         continue;

      assert(item->SubItems->Count > 0);
      AnsiString nymkey = item->SubItems->Strings[item->SubItems->Count - 1];
      Global->DB->GetNym(nymkey, profile);

      if (!CheckValidKeyForProfile((TForm*)Owner, PGP, profile))
      {
         delete Template;
         delete profile;
         return;
      }

      if (GenNymDeleteMessage((TForm*)Owner, Template))
      {
         TNymConfig *nymconfig = new TNymConfig((TForm*)Owner, PGP, profile);
         nymconfig->CreateDeleteMessage(Template);
         delete nymconfig;
      }
   }

   delete Template;
   delete profile;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::MessageReplayItemClick(TObject *Sender)
{
   assert(ListView->Selected != NULL);

   if (SecureModeMsg(Application->MainForm))
      return;
      
   TNymProfile *profile = new TNymProfile();
   TStringList *Template = new TStringList();

   for (int i = 0; i < ListView->Items->Count; i++)
   {
      TListItem *item = ListView->Items->Item[i];
      if (!item->Selected)
         continue;

      assert(item->SubItems->Count > 0);
      AnsiString nymkey = item->SubItems->Strings[item->SubItems->Count - 1];
      Global->DB->GetNym(nymkey, profile);

      if (!CheckValidKeyForProfile((TForm*)Owner, PGP, profile))
      {
         delete Template;
         delete profile;
         return;
      }

      if (GenNymReplayMessage((TForm*)Owner, Template))
      {
         TNymConfig *nymconfig = new TNymConfig((TForm*)Owner, PGP, profile);
         nymconfig->CreateReplayMessage(Template);
         delete nymconfig;
      }
   }

   delete Template;
   delete profile;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::MessageFrmNymItemClick(TObject *Sender)
{
   assert(ListView->Selected != NULL);

   if (SecureModeMsg(Application->MainForm))
      return;
      
   TNymProfile *profile = new TNymProfile();
   TStringList *Template = new TStringList();

   for (int i = 0; i < ListView->Items->Count; i++)
   {
      TListItem *item = ListView->Items->Item[i];
      if (!item->Selected)
         continue;

      assert(item->SubItems->Count > 0);
      AnsiString key = item->SubItems->Strings[item->SubItems->Count - 1];
      Global->DB->GetNym(key, profile);

      if (!CheckValidKeyForProfile((TForm*)Owner, PGP, profile))
      {
         delete Template;
         delete profile;
         return;
      }

      if (GenFromNymMessage((TForm*)Owner, Template))
      {
         TNymConfig *nymconfig = new TNymConfig((TForm*)Owner, PGP, profile);
         nymconfig->CreateFromNymMessage(Template);
         delete nymconfig;
      }
   }

   delete Template;
   delete profile;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::NymserverManager1Click(TObject *Sender)
{
   ManageNymserverAsc(Application->MainForm, AppDir() + NymserverFile);
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::Mail2newsManager1Click(TObject *Sender)
{
   ManageMail2newsTxt(Application->MainForm, AppDir() + Mail2newsFile);
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::ListViewCustomDrawItem( TCustomListView *Sender,
      TListItem *Item, TCustomDrawState State, bool &DefaultDraw)
{
   AnsiString nym = Item->SubItems->Strings[Item->SubItems->Count - 1];
   if (IsRetired(nym))
      ListView->Canvas->Font->Style = TFontStyles() << fsItalic;
   DefaultDraw = true;
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::Updaterlisttxt1Click(TObject *Sender)
{
   UpdateStatsAndKeys(Application->MainForm);
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::Nymreports1Click(TObject *Sender)
{
   RunNewNymReports(Application->MainForm);
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::Finger1Click(TObject *Sender)
{
   RunFingerTool(Application->MainForm);
}
//---------------------------------------------------------------------------

void __fastcall TNymsFrame2::ListViewMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   if (PGP)
   {
      //static int x = 0; x++;
      //Application->MainForm->Caption = " " + IntToStr(x);
      PGP->RandomMouseMoved();
   }
}
//---------------------------------------------------------------------------

