//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "NymGenModNowDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNymGenModDlg *NymGenModDlg;
//---------------------------------------------------------------------------

bool __fastcall GenNymModifyMessage(TForm *Owner, bool &Preview, TStrings *Template,
   bool &Commands, bool &Key, bool &ReplyBlock, TNymProfile *Profile)
{
   if (SecureModeMsg(Owner))
      return false;

   Template->Clear();

   NymGenModDlg = new TNymGenModDlg(Owner, Profile);
   Global->DB->GetTemplates(NymGenModDlg->TempList->Items);
   AnsiString name = Global->DB->GetIni(LastNymCfgTemplate, "nym-config");

   int idx = NymGenModDlg->TempList->Items->IndexOf(name);
   if (idx < 0)
   {
      name = "Anonymous Reply";
   }


   idx = NymGenModDlg->TempList->Items->IndexOf(name);
   if (idx >= 0)
   {
      NymGenModDlg->TempList->Perform(LB_SETTOPINDEX, idx, NULL);
      NymGenModDlg->TempList->Selected[idx] = true;
   }

   NymGenModDlg->CmdsBox->Checked = Commands;
   NymGenModDlg->RBBox->Checked = ReplyBlock;
   NymGenModDlg->PGPBox->Checked = Key;

   NymGenModDlg->ShowModal();
   bool ok = NymGenModDlg->ModalResult == mrOk;
   if (ok)
   {
      idx = NymGenModDlg->TempList->ItemIndex;
      name = NymGenModDlg->TempList->Items->Strings[idx];
      Global->DB->GetTemplate(name, Template);
      Global->DB->PutIni(LastNymCfgTemplate, name);

      Preview = NymGenModDlg->Preview->Checked;
      Commands = NymGenModDlg->CmdsBox->Checked;
      ReplyBlock = NymGenModDlg->RBBox->Checked;
      Key = NymGenModDlg->PGPBox->Checked;
   }

   delete NymGenModDlg;

   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall GenNymModifyMessage(TForm *Owner, bool &Preview, TStrings *Template,
   bool &Commands, bool &Key, bool &ReplyBlock, TNymProfile *Profile,
   const AnsiString &NewKey, const AnsiString &OldKey)
{
   if (SecureModeMsg(Owner))
      return false;

   Template->Clear();

   NymGenModDlg = new TNymGenModDlg(Owner, Profile);
   Global->DB->GetTemplates(NymGenModDlg->TempList->Items);
   NymGenModDlg->NewKeyBox->ItemIndex = NymGenModDlg->NewKeyBox->Items->IndexOf(NewKey);
   NymGenModDlg->OldKeyBox->ItemIndex = NymGenModDlg->OldKeyBox->Items->IndexOf(OldKey);
   AnsiString name = Global->DB->GetIni(LastNymCfgTemplate, "nym-config");

   int idx = NymGenModDlg->TempList->Items->IndexOf(name);
   if (idx < 0)
   {
      name = "Anonymous Reply";
   }

   idx = NymGenModDlg->TempList->Items->IndexOf(name);
   if (idx >= 0)
   {
      NymGenModDlg->TempList->Perform(LB_SETTOPINDEX, idx, NULL);
      NymGenModDlg->TempList->Selected[idx] = true;
   }

   NymGenModDlg->CmdsBox->Checked = Commands;
   NymGenModDlg->RBBox->Checked = ReplyBlock;
   NymGenModDlg->PGPBox->Checked = Key;
   NymGenModDlg->PGPBoxClick(NymGenModDlg->PGPBox);

   NymGenModDlg->ShowModal();
   bool ok = NymGenModDlg->ModalResult == mrOk;
   if (ok)
   {
      idx = NymGenModDlg->TempList->ItemIndex;
      name = NymGenModDlg->TempList->Items->Strings[idx];
      Global->DB->GetTemplate(name, Template);
      Global->DB->PutIni(LastNymCfgTemplate, name);

      Preview = NymGenModDlg->Preview->Checked;
      Commands = NymGenModDlg->CmdsBox->Checked;
      ReplyBlock = NymGenModDlg->RBBox->Checked;
      Key = NymGenModDlg->PGPBox->Checked;
   }

   delete NymGenModDlg;

   return ok;
}
//---------------------------------------------------------------------------

__fastcall TNymGenModDlg::TNymGenModDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TNymGenModDlg::TNymGenModDlg(TComponent* Owner, TNymProfile *Profile)
        : TForm(Owner)
{
   LoadFonts(AppIni(), NymIni, wincolor, Font, TempList->Font, NULL);
   TempList->Color = wincolor;

   PGPBox->Width = Canvas->TextWidth(PGPBox->Caption) + 20;
   for (int i = 0; i < Profile->Count; i++)
   {
      AnsiString keyid, line = Profile->Strings[i];
      if (line.Pos("Secret Key: ") == 1)
      {
         keyid = GetTok(2, line, ' ');
         if (NewKeyBox->Items->IndexOf(keyid) >= 0)
            continue;

         NewKeyBox->Items->Add(keyid);
         OldKeyBox->Items->Add(keyid);
      }
   }
   NewKeyBox->ItemIndex = -1;
   OldKeyBox->ItemIndex = -1;
   ActiveControl = TempList;
}
//---------------------------------------------------------------------------

void __fastcall TNymGenModDlg::RBBoxClick(TObject *Sender)
{
   Preview->Enabled = RBBox->Checked;
   if (!Preview->Enabled)
      Preview->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TNymGenModDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      if (!CmdsBox->Checked && !PGPBox->Checked && !RBBox->Checked)
      {
         MsgBox(this,
            "You need to select at least one item to include in the message or click Cancel.",
             MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      if (PGPBox->Checked && (NewKeyBox->ItemIndex == -1 || OldKeyBox->ItemIndex == -1))
      {
         MsgBox(this,
            "You have included the PGP key with this message so you must also select   \n"
            "select your nym's new key and it's previous key.",
             MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      if (TempList->ItemIndex < 0)
      {
         MsgBox(this,
            "You need to select a template or click Cancel.",
             MT_INFO, MB_OK);
         CanClose = false;
         return;
      }
   }
}
//---------------------------------------------------------------------------


void __fastcall TNymGenModDlg::TempListDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TNymGenModDlg::PGPBoxClick(TObject *Sender)
{
   bool checked = PGPBox->Checked;

   NewKeyBox->Enabled = checked;
   NewKeyBox->Color = checked ? wincolor : Color;

   OldKeyBox->Enabled = checked;
   OldKeyBox->Color = checked ? wincolor : Color;

   Label5->Enabled = checked;
   Label4->Enabled = checked;
}
//---------------------------------------------------------------------------

