//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "NymProbDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNymProbDlg *NymProbDlg;
//---------------------------------------------------------------------------

bool __fastcall GetReplyBlockProbability(TForm *Owner, AnsiString &Probability)
{
   bool ok = false;
   NymProbDlg = new TNymProbDlg(Owner);

   NymProbDlg->Value->Text = Probability;
   NymProbDlg->ShowModal();
   if (NymProbDlg->ModalResult == mrOk)
   {
      Probability = NymProbDlg->Value->Text;
      ok = true;
   }

   delete NymProbDlg;
   return ok;
}

//---------------------------------------------------------------------------

__fastcall TNymProbDlg::TNymProbDlg(TComponent* Owner)
        : TForm(Owner)
{
   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, Value->Font, NULL);
   Value->Color = color;
}
//---------------------------------------------------------------------------
void __fastcall TNymProbDlg::FormCloseQuery(TObject *, bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      // start by removing all spaces
      AnsiString probstr = Value->Text;
      int p; while ((p = probstr.Pos(" ")) > 0)
         probstr.Delete(p, 1);
      Value->Text = probstr;

      AnsiString prob = Value->Text;
      if (prob.IsEmpty())
         return;

      if (prob.Pos("=") == 0)
      {
         MsgBox(this,
            "Your entry must be in the form <name>=<value>.   ",
             MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      AnsiString name = GetTok(0, prob, '=');
      if (name.Length() > 1 || AnsiString("abcdefghijklmnopqrstuvwxyz").Pos(name) == 0)
      {
         MsgBox(this,
            "Your name value must be a single lowercase alpha character a..z'   ",
             MT_INFO, MB_OK);
         CanClose = false;
         return;
      }

      double value = GetTok(1, prob, '=').ToDouble();
      if (value <= 0 || value >= 1)
      {
         MsgBox(this, "Your probability value must be greater than 0 and less than 1   ",
            MT_INFO, MB_OK);
         CanClose = false;
         return;
      }
   }
}
//---------------------------------------------------------------------------
