//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "global2.h"
#include "RBCapWins.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRBCapWin *RBCapWin = NULL;
//---------------------------------------------------------------------------

void __fastcall OpenCapsToolWindow(TForm *Owner, const AnsiString &Remailer,
   const AnsiString &Caps, int X, int Y)
{
   if (SecureModeMsg(Owner))
      return;

   if (RBCapWin == NULL)
   {
      RBCapWin = new TRBCapWin(Owner);

      AnsiString xy = Global->DB->GetIni("remailercapswin", "");
      RBCapWin->Left = GetTok(0, xy, ',').ToIntDef(X);
      RBCapWin->Top = GetTok(1, xy, ',').ToIntDef(Y);

      int p = Caps.Pos(" ");
      RBCapWin->Display->Clear();
      RBCapWin->Display->Lines->Add(Caps.SubString(p + 1, 256));
      RBCapWin->Display->SelStart = 0;
      RBCapWin->Caption = " " + Remailer;
      //CapsToolWindowShow(Remailer, Caps);
      RBCapWin->Show();
   }
   else
   {
      int p = Caps.Pos(" ");
      RBCapWin->Display->Clear();
      RBCapWin->Display->Lines->Add(Caps.SubString(p + 1, 256));
      RBCapWin->Display->SelStart = 0;
      RBCapWin->Caption = " " + Remailer;
      //CapsToolWindowShow(Remailer, Caps);
      RBCapWin->BringToFront();
   }
}
//---------------------------------------------------------------------------

void __fastcall CapsToolWindowShow(const AnsiString &Remailer, const AnsiString &Caps)
{
   if (RBCapWin == NULL)
      return;

   int p = Caps.Pos(" ");
   RBCapWin->Display->Clear();
   RBCapWin->Display->Lines->Add(Caps.SubString(p + 1, 256));
   RBCapWin->Display->SelStart = 0;

   RBCapWin->Caption = " " + Remailer;
}
//---------------------------------------------------------------------------

__fastcall TRBCapWin::TRBCapWin(TComponent* Owner)
        : TForm(Owner)
{
   Display->Clear();

   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, Display->Font, NULL);
   Display->Color;
}
//---------------------------------------------------------------------------

void __fastcall TRBCapWin::FormClose(TObject *, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------

__fastcall TRBCapWin::~TRBCapWin()
{
   if (FileExists(AppDat()))
      Global->DB->PutIni("remailercapswin", IntToStr(Left) + "," + IntToStr(Top));
   RBCapWin = NULL;
}
//---------------------------------------------------------------------------

