//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "RBxtests.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)
const AnsiString cpkdirectives =
   "Null:,Rand-Hop:,Latent-Time:,Cutmarks:,Encrypt-Key:,Encrypt-3DES:,Encrypt-CAST:";
const AnsiString finalheaders =
   "Subject:,Newsgroups:,Followup-To:,From:,CC:,Cc:,Bcc:,Reply-To:";
const AnsiString m2nfile = AppDir() + "mail2news.txt";
const AnsiString rlisttxt = MixDir() + "rlist.txt";
const AnsiString nymserverasc = AppDir() + "nymserver.asc";
//---------------------------------------------------------------------------

__fastcall TReplyBlockTester::TReplyBlockTester()
  : TObject()
{
   TStringList *list = new TStringList();

   caps = new TStringList();
   remailers = new TStringList();
   GetRemailersAndCaps(remailers, caps);

look(remailers, "remailers");
look(caps,"caps");

   mail2news = new TStringList();
   if(FileExists(m2nfile))
      mail2news->LoadFromFile(m2nfile);

   headers = new TStringList();
   headers->CommaText = finalheaders;

   directives = new TStringList();
   directives->CommaText = cpkdirectives;

   delete list;
}
//---------------------------------------------------------------------------

__fastcall TReplyBlockTester::~TReplyBlockTester()
{
   delete directives;
   delete headers;
   delete mail2news;
   delete remailers;
   delete caps;
}
//---------------------------------------------------------------------------

void __fastcall TReplyBlockTester::GetRemailersAndCaps(TStrings *remailers, TStrings *caps)
{
   remailers->Clear();
   caps->Clear();

   AnsiString line;
   TStringList *list = new TStringList();
   if (FileExists(rlisttxt))
      list->LoadFromFile(rlisttxt);

   for (int i = 0; i < list->Count; i++)
   {
      line = list->Strings[i];
      if (line.Pos("%") > 0)
         remailers->Add(GetTok(0, line, ' '));
   }

   for (int i = 0; i < list->Count; i++)
   {
      line = list->Strings[i];
      if (line.Pos("$remailer{") == 1)
         caps->Add(GetTok(1, line, '"') + "=" + GetTok(3, line, '"') + " ");
   }

   if (FileExists(nymserverasc))
   {
      list->LoadFromFile(nymserverasc);
      for (int i = 0; i < list->Count; i++)
      {
         line = list->Strings[i];
         if (line.Pos("$nymserver{") == 1)
         {
            AnsiString server, backend;
            backend = GetTok(1, line, ';').Trim();
            server = GetTok(1, line, '"');
            line = server + "=" + GetTok(3, line, '"') + " ";
            if (!backend.IsEmpty())
               line += caps->Values[backend];
         }
      }
   }

   delete list;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::HasCap(const AnsiString &remailer, const AnsiString &cap)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::GetNextReplyBlock(TStrings *replyblock, TStrings *replyblocks)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::GetLeg(int index, TStrings *leg,
   TStrings *replyblock, bool &last)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::CheckValidReplyBlocks(TStrings *replyblocks)
{
   bool ok = true;
   TStringList *replyblock = new TStringList();

   while (GetNextReplyBlock(replyblock, replyblocks))
   {
       ok = CheckValidReplyBlock(replyblock);
       if (!ok)
          break;
   }

   delete replyblock;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::CheckValidReplyBlock(TStrings *replyblock)
{
   bool last, ok = true;
   TStringList *leg = new TStringList();

   int index = 0;
   while (GetLeg(index++, leg, replyblock, last))
   {
      ok = CheckValidLeg(leg, last);
      if (!ok || last)
         break;
   }

   delete leg;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::ValidRemailer(const AnsiString &line)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::ValidDirective(const AnsiString &line,
   const AnsiString &remailer)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::ValidToDirective(const AnsiString &line,
   const AnsiString &remailer)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::ValidPostDirective(const AnsiString &line,
   const AnsiString &remailer)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::ValidFinalHeader(const AnsiString &line)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TReplyBlockTester::CheckValidLeg(TStrings *leg, bool &last)
{
   bool ok, isDir, isHdr, hasTo = false;
   AnsiString remailer = leg->Strings[1];

   if (!ValidRemailer(remailer))
   {

   }

   for (int i = 0; i < leg->Count; i++)
   {
      isDir = false;
      isHdr = false;
      AnsiString line = leg->Strings[i];

      if (ValidPostDirective(line, remailer))
      {
         hasTo = true;
         continue;
      }

      if (ValidToDirective(line, remailer))
      {
         hasTo = true;
         continue;
      }

      if (ValidDirective(line, remailer))
      {
         continue;
      }

      if (ValidFinalHeader(line))
      {
         continue;
      }
   }

   if (!hasTo)
   {
   }

   return false;
}
//---------------------------------------------------------------------------
